// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "nshogi2.h"

#include "MainFrm.h"
#include "koma.h"
#include "NSDoc.h"
#include "NSView.h"
#include "Splash.h"
#include "optdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_CONNECT, OnUpdateMyIndicatorConnect)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_GAME, OnUpdateMyIndicatorGame)

	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	//ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	//ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	//ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
	
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_KIFUBAR, OnViewKifubar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_KIFUBAR, OnUpdateViewKifubar)
	ON_LBN_SELCHANGE(IDC_KIFULIST, OnSelChangeKifubar)
	ON_WM_TIMER()
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(IDBC_GO_BOTTOM, OnKifuDownBtn)
	ON_UPDATE_COMMAND_UI(IDBC_GO_BOTTOM, OnUpdateKifuDownBtn)
	ON_WM_MOUSEWHEEL()
	ON_WM_SIZE()
	ON_COMMAND(ID_APP_OPTION, OnAppOption)
	ON_UPDATE_COMMAND_UI(ID_APP_OPTION, OnUpdateAppOption)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_CONNECT,
	ID_INDICATOR_GAME
	//ID_INDICATOR_KANA,
	//ID_INDICATOR_CAPS,
	//ID_INDICATOR_NUM,
	//ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{


	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// o[
	if (!m_wndKifuBar.Create(this,IDD_KIFUDLGBAR,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_KIFUDLGBAR))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
	// o[
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	CString csKaishi;
	csKaishi.LoadString(IDS_KAISHI_KYOKUMEN);
	pList->AddString(csKaishi);
	pList->SetCurSel(0);

	// ^Co[		///////////////////////////////
	/*
	if (!m_wndTimeBar.Create(this,IDD_TIMEDLGBAR,
		CBRS_TOP|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_TIMEDLGBAR))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
	*/


	EnableDocking(CBRS_ALIGN_ANY);

	// Ԃł̃Rg[o[̕\\
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	CRegist* pRgst = &(pApp->m_rgst);


	ShowControlBar(&m_wndToolBar,	pRgst->m_bToolBar, FALSE);
	ShowControlBar(&m_wndStatusBar,	pRgst->m_bStatusBar, FALSE);
	ShowControlBar(&m_wndKifuBar,	pRgst->m_bKifuBar, FALSE);
	//ShowControlBar(&m_wndTimeBar,	TRUE, FALSE);

	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// c[o[
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// ^Co[
	//m_wndTimeBar.EnableDocking(CBRS_ALIGN_TOP|CBRS_ALIGN_BOTTOM);
	//DockControlBar(&m_wndTimeBar/*,AFX_IDW_DOCKBAR_TOP ,CRect(0,100,0,0)*/);

	
	//m_wndKifuBar.EnableDocking(CBRS_ALIGN_LEFT|CBRS_ALIGN_RIGHT);
	//DockControlBar(&m_wndKifuBar);
	//FloatControlBar(&m_wndKifuBar,CPoint(0,0),0);
	
	m_bShowKifuBar = TRUE;

	// Ԃi߂邽߂̃^C}
	SetTimer(ID_TIMER_SECOND, 1000, NULL);

	// CG: ȉ̃ubN̓XvbV XN[ R|[lgɂĒǉ܂
	CSplashWnd::ShowSplashScreen(this);
  
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB
    cs.cx = 640;
	cs.cy = 450;
    cs.x = (::GetSystemMetrics(SM_CXSCREEN) - cs.cx) / 2;
    cs.y = (::GetSystemMetrics(SM_CYSCREEN) - cs.cy) / 2; 
	//UpdateKifuBar();


	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

void CMainFrame::OnViewKifubar() 
{
	BOOL bVisible = ((m_wndKifuBar.GetStyle() & WS_VISIBLE) != 0);

	ShowControlBar(&m_wndKifuBar, !bVisible, FALSE);
	RecalcLayout();
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnUpdateViewKifubar(CCmdUI* pCmdUI) 
{
	BOOL bVisible = ((m_wndKifuBar.GetStyle() & WS_VISIBLE) != 0);
	pCmdUI->SetCheck(bVisible);
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::RedrawDlgbar()
{
	if( IsWindow(m_wndKifuBar.m_hWnd))
	{
		CRect rc, rcList;
		m_wndKifuBar.GetClientRect( &rc );
		if(rc.right>15&&rc.bottom>15)
		{
			CRect rcScreen = rc;
			CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
			pList->GetWindowRect(&rcList);
			m_wndKifuBar.ClientToScreen(&rcScreen);
			pList->SetWindowPos(&wndTop,
							0,0,
							rc.right-15,
							rc.bottom-(rcList.top-rcScreen.top)-15,
							SWP_NOMOVE);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
//
CListBox* CMainFrame::GetKifuBar() const
{

	if(m_wndKifuBar.m_hWnd==NULL)
	{
		AfxMessageBox( "DEBUG");
		exit(-1);
	}
	if( IsWindow(m_wndKifuBar.m_hWnd))
		return (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	
	return NULL;

}

/////////////////////////////////////////////////////////////////////////////
// o[NbNA̎_܂Ŋ߂\

void CMainFrame::OnSelChangeKifubar()
{
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	((CNSDoc*)GetActiveDocument())->ReplayKoma(pList->GetCurSel());

	PrintNodeCount(pList);
	
	((CNSView*)GetActiveView())->InvalidateRect( NULL, FALSE );

	return;
}

/////////////////////////////////////////////////////////////////////////////
// 

void CMainFrame::OnTimer(UINT nIDEvent) 
{

	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	// Ԃ̕\
	if( pDoc->m_bOnGame == TRUE )
	{
		PrintTime(pDoc);
	}
	
	if(pDoc!=NULL)
		pDoc->MyTimer(nIDEvent);
	CNSView* pView = (CNSView*)GetActiveView();
	if(pView!=NULL)
		pView->MyTimer(nIDEvent);

	CFrameWnd::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnFileNew() 
{
	// TODO:
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	pList->ResetContent();

	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	if(pDoc!=NULL)
		pDoc->OnNewDocument();
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnKifuDownBtn()
{
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	pList->SetCurSel(pList->GetCount()-1);
	OnSelChangeKifubar();
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnUpdateKifuDownBtn(CCmdUI* pCmdUI)
{
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	
	if( pList->GetCount()-1 == pList->GetCurSel() )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );

}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::UpdateKifuBar()
{
	PrintBtlName();

	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	if(pDoc==NULL)
		return;

	// Document̊o[ɔf
	// Xg{bNX̎擾
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);

	// |C^̎擾
	CPtrList* pKifu = pDoc->m_pKifu;
	if( pKifu == NULL )
		return;

	// t@CXg̎č\z
	if(pKifu->GetCount()<pList->GetCount())
	{
		// o[ƊSVN
		SyncKifuBar();
		return;
	}

	// Ԃ̕\
	//if( pDoc->m_bOnGame == TRUE )
	{
		PrintTime(pDoc);
	}

	// ̕\
	int index = 0;
    for(POSITION pos=pKifu->GetHeadPosition(); pos!=NULL;index++)
    {
		// Doc̊Xgf[^
		DWORD dwData = (DWORD)pKifu->GetNext( pos );
		DWORD dwBoxData = pList->GetItemData(index);
		if( dwBoxData != dwData )
		{
			// Ō̊t@CXg̃f[^
			// ܂ĂȂ̂ł̎͒ǉĂB
			if( index == pList->GetCount() )// Ō+1wĂ鎞
				AddListTail(dwData);
			else
			{
				SyncKifuBar();
				return;
			}

		}
    }
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::PrintBtlName()
{
	CWnd* pTopName = m_wndKifuBar.GetDlgItem(IDSC_TOP_NAME);
	CWnd* pBtmName = m_wndKifuBar.GetDlgItem(IDSC_BOTTOM_NAME);

	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	if(pDoc==NULL)
		return;
	if(pDoc->m_pSocket == NULL/*!pDoc->m_bOnGame&&!pDoc->m_bIamGallary*/)
	{
		pTopName->SetWindowText("");
		pBtmName->SetWindowText("");
		return;
	}
	if( pDoc->m_nViewSide == SENTE )
	{
		pTopName->SetWindowText(pDoc->m_szGoteName);
		pBtmName->SetWindowText(pDoc->m_szSenteName);
	}
	else //pDoc->m_nMySide == GOTE
	{
		pTopName->SetWindowText(pDoc->m_szSenteName);
		pBtmName->SetWindowText(pDoc->m_szGoteName);
	}
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::SyncKifuBar()
{
	// Xg{bNX̎擾
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	pList->ResetContent();

	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	if(pDoc==NULL)
		return;

	CPtrList* pKifu = pDoc->m_pKifu;

	if( pKifu == NULL )
		return;

	pDoc->m_koma.Init();
	int index = 0;
	for(POSITION pos=pKifu->GetHeadPosition(); pos!=NULL;index++)
	{
		// Doc̊Xgf[^
		DWORD dwData = (DWORD)pKifu->GetNext( pos );
		AddListTail(dwData);
	}
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::AddListTail(DWORD dwData)
{
	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	if(pDoc==NULL)
		return;

	int no, status, listindex = 0;
	CPoint cp, cpLast;
	BOOL	bActive;
	CPtrList* pKifu = pDoc->m_pKifu;
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	
	if( pKifu == NULL )
		return;

	CKoma* pKoma = &(pDoc->m_koma);
	if( pKoma == NULL )
		return;

	int index;

	// f[^𕪉
	no = HIWORD(dwData);
	// f[^̎
	if( 0 <= no && 39 >= no )
	{
		CString csKifu,csSide,csName,csPoint;
		status = LOWORD(dwData);

		// f[^𔽉f
		pKoma->SetWord(KOMA_USER,(WORD)status);
		if( !pKoma->IsEnable(KOMA_USER) )
			return;
		
		cp = pKoma->GetPoint(KOMA_USER);				// ǂֈړ̂
		pKoma->Move(no, cp, TRUE);						// ۂɈړ

		cpLast = pKoma->GetPoint(KOMA_LASTMOVED_FROM);	// ǂړ̂
		bActive = pKoma->IsActive(KOMA_LASTMOVED_FROM);	// ͔ړ̂H()

		if(pKoma->IsNari(KOMA_USER))				//
			pKoma->SetNari(no, TRUE);
		// 쐬ăXg{bNXɂoB
		// 肩肩
		csSide = (pKoma->GetSide(no) == SENTE ? _T(""):_T("") );
		
		// O
		csName = pKoma->GetName(KOMA_LASTMOVED);

		// 肩ǂ
		char *kanji[] = {"","","O","l","","Z","","",""};
		char *arabi[] = {"P","Q","R","S","T","U","V","W","X"};
		if(!pKoma->IsNari(KOMA_LASTMOVED)&&pKoma->IsNari(KOMA_USER))
			csName += _T("");
		if(!bActive)
			csName += _T("");


		// ꏊ
		// Ő̈ʒu
		/*
		DWORD PrevData;
		POSITION pos = pKifu->GetTailPosition();	// Ō̃|WV
		if(pos!=NULL)
			pKifu->GetPrev(pos);
		if(pos!=NULL)
			PrevData = (DWORD)pKifu->GetPrev(pos);
		pKoma->SetWord(KOMA_USER,LOWORD(PrevData));
		*/
#ifdef _DEBUG

		CString dbg;
		dbg.Format("KOMA_USER x:%d y:%d\n", cp.x, cp.y);
		TRACE0(dbg);

#endif
		CPoint cpLastMoved;
		DWORD dwLastData = pList->GetItemData(pList->GetCount()-1);
		pKoma->SetWord(KOMA_USER, LOWORD(dwLastData));

		if( HIWORD(dwLastData) < 0 || HIWORD(dwLastData) > 39 )
		{
			cpLastMoved = CPoint(-1,-1);
		}
		else
		{
			cpLastMoved = pKoma->GetPoint(KOMA_USER);
		}

		if( cp == cpLastMoved )
		{
			csPoint = _T("@");
		}
		else
		{
			csPoint.Format( "%s%s",arabi[8-cp.x],kanji[cp.y] );
		}

		////////////////////////////////////////////////////////
		if(bActive) // oꍇ͈ړW͂ȂB
		{
			csKifu.Format( "%s%s%s(%1d%1d)", 
					csSide, csPoint ,csName, 8-cpLast.x+1, cpLast.y+1 );
		}
		else
		{
			csKifu.Format( "%s%s%s", 
					csSide, csPoint ,csName );
		}
#ifdef _DEBUG
		{
		CString dbg;
		dbg.Format("%s | %x", csKifu, dwData);
		index = pList->AddString(dbg);
		}
#else
		index = pList->AddString(csKifu);
#endif
	}
	//////////////////////////////////////////////////////////////
	// ȊÕf[^̎
	else
	{
		CString cs;
		switch( no )
		{
		case KOMA_GAME_START:
			//cs = _T("Jnǖ");
			cs.LoadString(IDS_KAISHI_KYOKUMEN);
			break;
		case KOMA_SENTE_TORYO:
			//cs = _T("蓊");
			cs.LoadString(IDS_SENTE_TOURYOU);
			break;
		case KOMA_GOTE_TORYO:
			//cs = _T("蓊");
			cs.LoadString(IDS_GOTE_TOURYOU);
			break;
		case KOMA_SENTE_SYORI:
			//cs = _T("菟");
			cs.LoadString(IDS_SENTE_SYOURI);
			break;
		case KOMA_GOTE_SYORI:
			//cs = _T("菟");
			cs.LoadString(IDS_GOTE_SYOURI);
			break;
		case KOMA_SENTE_TIMEOUT:
			//cs = _T("莞Ԑ؂");
			cs.LoadString(IDS_SENTE_TIMEOUT);
			break;
		case KOMA_GOTE_TIMEOUT:
			//cs = _T("莞Ԑ؂");
			cs.LoadString(IDS_GOTE_TIMEOUT);
			break;
		default:
			cs = _T("????");
			break;
		}
		index = pList->AddString(cs);
	}
	pList->SetCurSel(index);
	pList->SetItemData(index,dwData);

	// ڂ\
	PrintNodeCount(pList);

	// fobO
/*
#ifdef _DEBUG
	{
		CString csKifu,csSide;
		// f[^𔽉f
		cp = pKoma->GetPoint(KOMA_LASTMOVED);
		// 쐬ăXg{bNXɂoB
		csSide = (pKoma->GetSide(KOMA_LASTMOVED) == SENTE ? _T(""):_T("") );

		csKifu.Format( "%s%d%d%s", csSide, cp.x+1,cp.y+1, pKoma->GetName(KOMA_LASTMOVED));
		TRACE0(csKifu);
	}
#endif
*/
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::PrintNodeCount(CListBox* pList)
{
	CStatic* pIndex = (CStatic*)m_wndKifuBar.GetDlgItem(IDSC_INDEX);
	CString cs;
	cs.Format( "%d", pList->GetCurSel() );
	pIndex->SetWindowText(cs);

	((CNSView*)GetActiveView())->InvalidateRect( NULL, FALSE );
}

/////////////////////////////////////////////////////////////////////////////
//
BOOL CMainFrame::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	// TODO:
	CListBox* pList = (CListBox*)m_wndKifuBar.GetDlgItem(IDC_KIFULIST);
	int now = pList->GetCurSel();
	if( now != LB_ERR )
	{
		if( zDelta >= 120 && now > 0)
			pList->SetCurSel(now-1);
		else if( zDelta<=-120 && now < pList->GetCount() )
			pList->SetCurSel(now+1);
	}
	OnSelChangeKifubar();
	return CFrameWnd::OnMouseWheel(nFlags, zDelta, pt);

}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	
	// TODO:
	RedrawDlgbar();
	
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnUpdateMyIndicatorConnect(CCmdUI *pCmdUI)
{
    pCmdUI->Enable();
	CString str;
	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	ASSERT_VALID(pDoc);

	if(pDoc->m_pSrvSocket == NULL )
		(pDoc->m_pSocket==NULL)?str="":str="ڑ";
	else
		str = "ҋ@";

	pCmdUI->SetText( str ); 
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnUpdateMyIndicatorGame(CCmdUI *pCmdUI)
{
	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	ASSERT_VALID(pDoc);

	if( pDoc->m_pSocket == NULL )
	{
		pCmdUI->SetText( _T("EEE") );
		return;
	}
    
	if( pDoc->m_bIamGallary )
	{
		pCmdUI->SetText( _T("ϐ풆") );
		return;
	}
	
	if(pDoc->m_bOnGame)
		pCmdUI->SetText( _T("΋ǒ") );
	else
		pCmdUI->SetText( _T("΋Ǒ") );

}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnAppOption() 
{
	// TODO:
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	CRegist* pRgst = &(pApp->m_rgst);

	CNSDoc* pDoc = (CNSDoc*)GetActiveDocument();
	ASSERT_VALID(pDoc);

	COptDlg	dlg(pRgst);
	dlg.m_bWatchAllow	=	pRgst->m_bWatchAllow;
	dlg.m_nFlashOn		=	pRgst->m_nFlashOn;
	dlg.m_bNoticeDialog =	pRgst->m_nMessageOn;
	dlg.m_bNoticeOute =		pRgst->m_bOuteNotice;
	dlg.m_bNoticeSound =	pRgst->m_nSoundOn;
	dlg.m_bPrintRoot =		pRgst->m_bPrintRoot;
	dlg.m_bViewGray =		pRgst->m_bViewGray;
	

	if (dlg.DoModal() == IDOK)
	{
		pRgst->m_bWatchAllow	=	dlg.m_bWatchAllow;
		pRgst->m_nFlashOn		=	dlg.m_nFlashOn;
		pRgst->m_nMessageOn		=	dlg.m_bNoticeDialog;
		pRgst->m_bOuteNotice	=	dlg.m_bNoticeOute;
		pRgst->m_nSoundOn	=		dlg.m_bNoticeSound;
		pRgst->m_bPrintRoot =		dlg.m_bPrintRoot;

		// ɔfl
		pDoc->m_nSenteTime = pRgst->m_nTime;
		pDoc->m_nGoteTime = pRgst->m_nTime;
		pDoc->m_nCounter = pRgst->m_nDefaultCounter;

		// ĕ`悪Kvȏ
		if((pRgst->m_nViewSize != dlg.m_nViewSize) ||
			(pRgst->m_bViewGray != dlg.m_bViewGray) )
		{
			pRgst->m_nViewSize = dlg.m_nViewSize;
			pRgst->m_bViewGray = dlg.m_bViewGray;
			((CNSView*)GetActiveView())->ReSizeView(TRUE);
		}
	}
	pRgst->Save();
	UpdateKifuBar();

}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnUpdateAppOption(CCmdUI* pCmdUI) 
{
	// TODO:
	// ł\
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO:
	// t@C_uNbNċNA
	// ̂߂ɈxĂяo֐
	static flag = 0;
	if( !flag )
	{
		flag = 1;
		UpdateKifuBar();
	}
	// `pbZ[WƂ CFrameWnd::OnPaint() ĂяoĂ͂܂
}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::OnDestroy() 
{
	
	// TODO:
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	CRegist* pRgst = &(pApp->m_rgst);

	BOOL bVisible = ((m_wndKifuBar.GetStyle() & WS_VISIBLE) != 0);

	pRgst->m_bToolBar =   (m_wndToolBar.GetStyle() & WS_VISIBLE);
	pRgst->m_bStatusBar = (m_wndStatusBar.GetStyle() & WS_VISIBLE);
	pRgst->m_bKifuBar =   (m_wndKifuBar.GetStyle() & WS_VISIBLE);
	
	pRgst->Save();
	
	CFrameWnd::OnDestroy();

}

/////////////////////////////////////////////////////////////////////////////
//
void CMainFrame::PrintTime(CNSDoc * pDoc)
{
	CString cs;

	CWnd* pTime = m_wndKifuBar.GetDlgItem(IDSC_TIME_SENTE);
	int Sec = pDoc->m_nSenteTime%60;
	int Min = pDoc->m_nSenteTime/60;
	cs.Format("%d:%02d",Min, Sec );
	pTime->SetWindowText(cs);

	pTime = m_wndKifuBar.GetDlgItem(IDSC_TIME_GOTE);
	Sec = pDoc->m_nGoteTime%60;
	Min = pDoc->m_nGoteTime/60;
	cs.Format("%d:%02d",Min, Sec );
	pTime->SetWindowText(cs);

	pTime = m_wndKifuBar.GetDlgItem(IDSC_TIME_COUNT);
	if( pDoc->m_bCountUp )
	{
		pTime->ShowWindow(SW_SHOW);
		Sec = pDoc->m_nCounter%60;
		Min = pDoc->m_nCounter/60;
		cs.Format("%d:%02d",Min, Sec );
		pTime->SetWindowText(cs);
	}
	else
	{
		pTime->ShowWindow(SW_HIDE);
	}

	/*
	if( pDoc->m_bCountUp )
	{
		if(m_pKifu->GetCount()%2!=0)
		if( m_nSenteTime > 0 )
		{

		CProgressCtrl* pTimerBar = m_wndKifuBar.GetDlgItem(IDC_TIMER);
*/
}

