// NewBtlDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "nshogi2.h"
#include "NewBtlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewBtlDlg _CAO


CNewBtlDlg::CNewBtlDlg(CKoma* pKoma, CWnd* pParent /*=NULL*/)
	: CDialog(CNewBtlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewBtlDlg)
	m_e_count = 30;
	m_e_hour = 1;
	m_e_min = 0;
	m_bLimitTime = FALSE;
	//}}AFX_DATA_INIT
}


void CNewBtlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewBtlDlg)
	DDX_Control(pDX, IDC_SPIN_MIN, m_spin_min);
	DDX_Control(pDX, IDC_SPIN_HOUR, m_spin_hour);
	DDX_Control(pDX, IDC_SPIN_COUNT, m_spin_count);
	DDX_Text(pDX, IDC_E_COUNT, m_e_count);
	DDV_MinMaxInt(pDX, m_e_count, 0, 100);
	DDX_Text(pDX, IDC_E_HOUR, m_e_hour);
	DDV_MinMaxInt(pDX, m_e_hour, 0, 48);
	DDX_Text(pDX, IDC_E_MIN, m_e_min);
	DDV_MinMaxInt(pDX, m_e_min, 0, 59);
	DDX_Check(pDX, IDC_LIMITTIME, m_bLimitTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewBtlDlg, CDialog)
	//{{AFX_MSG_MAP(CNewBtlDlg)
	ON_BN_CLICKED(IDC_RADIOSENTE, OnRadiosente)
	ON_BN_CLICKED(IDC_RADIOGOTE, OnRadiogote)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewBtlDlg bZ[W nh

BOOL CNewBtlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// 胉WI{^̐ݒ
	CButton* lpRadioSente = (CButton*)(GetDlgItem(IDC_RADIOSENTE));
	lpRadioSente->SetCheck(TRUE);
	m_bSente = TRUE;
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	//m_cmbUwate.SetCurSel( m_pKoma->m_nOti );
	m_spin_hour.SetRange( 0, 5 );
	m_spin_hour.SetBase( 10 );
	m_spin_hour.SetPos( m_e_hour );

	m_spin_min.SetRange( 0, 59 );
	m_spin_min.SetBase( 10 );
	m_spin_min.SetPos( m_e_min );

	m_spin_count.SetRange( 10, 100 );
	m_spin_count.SetBase( 10 );
	m_spin_count.SetPos( m_e_count );

	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	CRegist* pRgst = &(pApp->m_rgst);

	// Ԑݒ
	m_bLimitTime =	pRgst->m_bCountUp;
	m_e_hour	=	pRgst->m_nTime/3600;
	m_e_min		=	(pRgst->m_nTime - m_e_hour * 3600) / 60;
	m_e_count	=	pRgst->m_nDefaultCounter;

	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


void CNewBtlDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ

	CDialog::OnOK();
}

void CNewBtlDlg::OnRadiosente() 
{
	// TODO:
	m_bSente = TRUE;
	
}

void CNewBtlDlg::OnRadiogote() 
{
	// TODO:
	m_bSente = FALSE;
	
}
