#include "stdafx.h"		//MFC
#include "koma.h"

IMPLEMENT_DYNCREATE(CKoma, CObject)

//////////////////////////////////////////////////////////////////////////////
//
void CKoma::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{
		ar << m_wStatus[50];
		ar << m_nOti;
	}
	else
	{
		ar >> m_wStatus[50];
		ar >> m_nOti;
	}
}

CKoma::CKoma()
{
	m_nOti = 0;
	Init();
}


//////////////////////////////////////////////////////////////////////////////
//

void CKoma::Init()
{
	ZeroMemory( &m_wStatus[0], sizeof(WORD)*64 );
	/* ftHg̒l */
	SetStatus( 0,GYOKU,	CPoint( 4, 8 ), SENTE );
	SetStatus( 2,HISYA,	CPoint( 7, 7 ), SENTE );
	SetStatus( 4,KAKU,	CPoint( 1, 7 ), SENTE );
	SetStatus( 6,KIN,	CPoint( 3, 8 ), SENTE );
	SetStatus( 8,KIN,	CPoint( 5, 8 ), SENTE );
	SetStatus( 10,GIN,	CPoint( 2, 8 ), SENTE );
	SetStatus( 12,GIN,	CPoint( 6, 8 ), SENTE );
	SetStatus( 14,KEIMA,CPoint( 1, 8 ), SENTE );
	SetStatus( 16,KEIMA,CPoint( 7, 8 ), SENTE );
	SetStatus( 18,KYOSYA,CPoint( 0, 8 ), SENTE );
	SetStatus( 20,KYOSYA,CPoint( 8, 8 ), SENTE );
	for( int ii = 22; ii < 31; ii++ )
		SetStatus( ii,FU, CPoint( ii-22, 6 ), SENTE );

	SetStatus( 1,GYOKU,CPoint( 4, 0 ), GOTE );
	SetStatus( 3,HISYA,CPoint( 1, 1 ), GOTE );
	SetStatus( 5,KAKU,	CPoint( 7, 1 ), GOTE );
	SetStatus( 7,KIN,	CPoint( 3, 0 ), GOTE );
	SetStatus( 9,KIN,	CPoint( 5, 0 ), GOTE );
	SetStatus( 11,GIN,	CPoint( 2, 0 ), GOTE );
	SetStatus( 13,GIN,	CPoint( 6, 0 ), GOTE );
	SetStatus( 15,KEIMA,CPoint( 1, 0 ), GOTE );
	SetStatus( 17,KEIMA,CPoint( 7, 0 ), GOTE );
	SetStatus( 19,KYOSYA,CPoint( 0, 0), GOTE );
	SetStatus( 21,KYOSYA,CPoint( 8, 0), GOTE );
 	for( ii = 31; ii < 40; ii++ )
		SetStatus( ii, FU, CPoint( ii-31, 2 ), GOTE );

	SetWord( KOMA_LASTMOVED, 0 );
	SetWord(KOMA_USER,0);
	SetWord(KOMA_GAME_START,0);
	SetWord(KOMA_SENTE_TORYO,0);
	SetWord(KOMA_GOTE_TORYO,0);
	SetWord(KOMA_SENTE_SYORI,0);
	SetWord(KOMA_GOTE_SYORI,0);
	SetWord(KOMA_SENTE_TIMEOUT,0);
	SetWord(KOMA_GOTE_TIMEOUT,0);

	m_nLastMovedNo = 0;

	switch( m_nOti )
	{
		case OTI_KYOSYA:
		{
			SetEnable(18,FALSE);
			break;
		}
		case OTI_KAKU:
		{
			SetEnable(4,FALSE);
			break;
		}
		case OTI_HISYA:
		{
			SetEnable(2,FALSE);
			break;
		}
		case OTI_HISYAKYO:
		{
			SetEnable(2,FALSE);
			SetEnable(18,FALSE);
			break;
		}
		case OTI_2MAI:
		{
			SetEnable(2,FALSE);
			SetEnable(4,FALSE);
			break;
		}
		case OTI_4MAI:
		{
			SetEnable(2,FALSE);
			SetEnable(4,FALSE);
			SetEnable(18,FALSE);
			SetEnable(20,FALSE);
			break;
		}
		case OTI_6MAI:
		{
			SetEnable(2,FALSE);
			SetEnable(4,FALSE);
			SetEnable(18,FALSE);
			SetEnable(20,FALSE);
			SetEnable(14,FALSE);
			SetEnable(16,FALSE);
			break;
		}
		default:
		{
			m_nOti = 0;
			break;
		}
	}
}


//////////////////////////////////////////////////////////////////////////////
//

int	CKoma::Move( int no, CPoint cpDst, BOOL bMove /* = TRUE */ )
{
	int yy;

	// ---------------------
	// ---Iȃ`FbN---
	// ---------------------
	// Cl[u
	if( !IsEnable( no ) )
		return MV_DISABLE;
	
	// Ղ̊O
	if( CRect( 0, 0, 9, 9 ).PtInRect(cpDst) == FALSE )
		return MV_OUTOFBAN;

	// ȑOƕςȂ
	if( cpDst == GetPoint( no ) )
		return MV_NOTCHANGE;

	int nDstKomaNo = SerchKomaByPoint( cpDst );

	// ړɋ肻ꂪ̋̏ꍇ
	if( ( nDstKomaNo != -1 ) &&
		( GetSide( nDstKomaNo ) == GetSide( no ) ))
			return MV_SAMESIDE;

	// --------------------------
	// ---ړꍇ---
	// --------------------------
	CPoint cpMe = GetPoint( no );

	if( IsActive( no ) == FALSE )
	{
		// ̂Ƃɂ͒uȂ
		if( nDstKomaNo != -1 )
			return MV_CANNOTDROP;

		// ̏ꍇ͓̃`FbN
		if( GetID( no ) == FU )
		{
			int serch;
			for( yy = 0; yy < 9; yy++ )
			{
				serch = SerchKomaByPoint( CPoint( cpDst.x, yy ) );
				// w̕ŁuƁvȂĂȂƂȂ
				if(( GetSide(serch)==GetSide(no)&&
					GetID( serch ) == FU )&& 
					!IsNari( serch )&&
					IsEnable( serch ) )
					return MV_NIFU;
			}
		}
				
		//̑ȊO͋󂫃Xy[XȂړ\
		if( IsActive( no ) == FALSE )
		{
			if( bMove )
			{
				
				SetWord( KOMA_LASTMOVED_FROM, GetWord(no) );
				
				// ړ
				SetPoint( no, cpDst );
				SetActive( no, TRUE );

				// ړL
				SetWord( KOMA_LASTMOVED, GetWord( no ) );
				m_nLastMovedNo = (WORD)no;
				// ړ
				//SetPoint( no, cpDst );
				//SetActive( no, TRUE );
			}
			return MV_OK;
		}
	} // ړꍇI

	// ---------------------------
	// --- ŗL̈ړ`FbN ---
	// ---------------------------
	// ̏ꍇAʒu𔽓]Ĕ肷
	BOOL ret;
	if(GetSide(no)==GOTE)
	{
		ReverseAll();
		cpDst = CPoint(8,8) - cpDst;
		ret = CheckMovePoint( no, cpDst );
		ReverseAll();
		cpDst = CPoint(8,8) - cpDst;
	}
	else
	{
		ret = CheckMovePoint( no, cpDst );
	}

	if( bMove && ret )
	{
		// ړOɋL
		SetWord( KOMA_LASTMOVED_FROM, GetWord(no) );

		// Ύ
		int serch = SerchKomaByPoint( CPoint( cpDst ) );
		if( serch != -1 )
		{
			// 
			SetActive( serch, FALSE );
		}

		SetActive( no,TRUE );

		// ̈ʒuړ
		SetPoint( no, cpDst );

		// ړL
		SetWord( KOMA_LASTMOVED, GetWord(no) );
		m_nLastMovedNo = (WORD)no;
	}

	if( ret )
	{
		return MV_OK;
	}
	else
		return MV_CANNOTMOVE;

	

}


//////////////////////////////////////////////////////////////////////////////
//
//---------------------------------
// ̓`FbN
// ȀԂfłȂ̂
// ̏ꍇ͐ɋ𔽓]
//---------------------------------

BOOL CKoma::CheckMovePoint( int no, CPoint cpDst )
{
	int ii,jj;
	
	int x, y, absx, absy;
	CPoint cpOrg = GetPoint( no );
	absx = abs( x = cpDst.x - cpOrg.x );
	absy = abs( y = cpDst.y - cpOrg.y );

	// ɂȂĂ̓iԊpȊOj

	if( IsNari(no) && (GetID(no)!= HISYA && GetID(no)!= KAKU))
	{
		if( ((absx>1) || (absy>1)) || (absx==1 && y==1) )
			return FALSE;
		else
			return TRUE;
	}
	
	switch( GetID(no) )
	{
	////// 
	case GYOKU:
		if( ( absx > 1) || ( absy > 1) )
			return FALSE;
		break;
	////// 
	case HISYA:
		if( IsNari(no) && !((absx>1) || (absy>1)) )
			return TRUE;
		if( (x!=0 && y!=0) )
			return FALSE;

		if( y == 0 )
		{
			for( ii = cpOrg.x; ii != cpDst.x; ii += (x/absx) )
			{
				int serchNo = SerchKomaByPoint( CPoint(ii,cpDst.y) );

				if(serchNo>-1 && serchNo != no && IsEnable( serchNo ))
					return FALSE;
			}
		}
		if( x == 0 )
		{
			for( ii = cpOrg.y; ii != cpDst.y; ii += (y/absy) )
			{
				int serchNo = SerchKomaByPoint( CPoint(cpDst.x,ii) );

				if(serchNo>-1 && serchNo != no && IsEnable( serchNo ))
					return FALSE;
			}
		}
		break;
	////// p
	case KAKU:
		if( IsNari(no) && !( (absx>1) || (absy>1)) )
			return TRUE;

		if( absx!=absy )	// ΂߈ړȊO͕s
			return FALSE;

		for( ii = cpOrg.x, jj = cpOrg.y;
				ii != cpDst.x;ii += ( x / absx ),jj += ( y / absy ) )
		{
			int serchNo = SerchKomaByPoint( CPoint(ii,jj) );

			if(serchNo>-1 && serchNo != no && IsEnable( serchNo ))
				return FALSE;
		}
		break;
	//////
	case KIN:
		if( ((absx>1) || (absy>1))  || ( absx==1 && y==1 ))
			return FALSE;
		break;
	//////
	case GIN:
		if( ((absx>1) || (absy>1)) ||
			( absx==1 && y==0 ) || ( x==0 && y==1 ) )
			return FALSE;
		break;
	//////
	case KEIMA:
		if( !(absx==1 && y==-2) )
			return FALSE;
		break;
	//////
	case KYOSYA:
		// Oinj
		if( !(x==0 && y<0) )	// ނ͋Ȃ
			return FALSE;
		for( ii = cpOrg.y - 1; ii != cpDst.y; ii-- )
		{
			if(SerchKomaByPoint( CPoint(cpDst.x,ii) )>-1)
				return FALSE;
		}
		break;
	//////
	case FU:
		// Oinj
		if( !(absx==0 && y==-1) ) 
			return FALSE;
		break;

	default:
		break;
	}
	return TRUE;

}


//////////////////////////////////////////////////////////////////////////////
// ՈʒûmT

int	CKoma::SerchKomaByPoint( CPoint cp )
{
	for( int no = 0; no < 40; no++ )
	{
		if( GetPoint( no ) == cp && IsEnable( no ) )
			return no;
	}
	return -1;
}
int CKoma::SerchKomaByPoint( int x, int y )
{
	return SerchKomaByPoint( CPoint( x, y ) );
}


//////////////////////////////////////////////////////////////////////////////
// r

WORD	CKoma::SetWord( int no, WORD w )
{
	if( no >= KOMA_GAME_START || no < 0 )
		return 0;
	m_wStatus[no] = w;
	return w;
}


//////////////////////////////////////////////////////////////////////////////
// 

inline CPoint	CKoma::SetPoint( int no, CPoint cp )
{
	if( no > 39 || no < 0 )
		return CPoint( 15,15 );
	WORD x = (WORD)cp.x;
	WORD y = (WORD)cp.y;
	x<<=12;
	y<<=8;
	m_wStatus[no] &= 0x0FF;
	m_wStatus[no] |= (x|y);
	return cp;
}


//////////////////////////////////////////////////////////////////////////////
// 
inline CPoint	CKoma::SetPoint( int no, int x, int y )
{
	return SetPoint( no, CPoint( x, y ) );
}


//////////////////////////////////////////////////////////////////////////////
// ID̐ݒ
inline BOOL	CKoma::SetID( int no, KOMAID kid )
{
	if( no > 39 || no < 0 )
		return FALSE;

	m_wStatus[no] &= 0xFFF8;
	m_wStatus[no] |= (DWORD)kid;

	// ʁA͐ȂB
	if(kid==GYOKU || kid== KIN)
		m_wStatus[no] &= ~KOMA_CANGROW;
	else
		m_wStatus[no] |= KOMA_CANGROW;
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
// ̐ݒ

inline BOOL	CKoma::SetSide( int no, BOOL b  /*= SENTE*/ )
{
	if( no > 39 || no < 0 )
		return FALSE;

	if( b )
		m_wStatus[no] |= KOMA_SIDE;
	else
		m_wStatus[no] &= ~KOMA_SIDE;

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
// ̔]

inline BOOL	CKoma::ChangeSide( int no )
{
	if( no > 39 || no < 0 )
		return FALSE;

	if(GetSide(no)==SENTE)
		m_wStatus[no] &= ~KOMA_SIDE;
	else
		m_wStatus[no] |= KOMA_SIDE;

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
// ɂ

BOOL	CKoma::SetNari( int no, BOOL b /*= TRUE*/ )
{
	if( no > 39 || no < 0 )
		return FALSE;

	WORD	w = m_wStatus[no];
	w &= KOMA_CANGROW;
	if( b && w )
		m_wStatus[no] |= KOMA_NARI;
	else
		m_wStatus[no] &= ~KOMA_NARI;

	return TRUE;
}

///////// ՏɐݒuA͔r
inline BOOL	CKoma::SetActive( int no, BOOL b /*= TRUE*/ )
{
	if( no > 39 || no < 0 )
		return FALSE;

	if( b )
		m_wStatus[no] |= KOMA_ACTIVE;
	else
	{
		m_wStatus[no] &= ~KOMA_ACTIVE;
		SetPoint( no, 15,15 );
		SetNari( no, FALSE );
		ChangeSide( no );
	}

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
// LtO

BOOL	CKoma::SetEnable(int no, BOOL b)
{
	if( no > 39 || no < 0 )
		return FALSE;

	if( b )
		m_wStatus[no] |= KOMA_ENABLE;
	else
	{
		m_wStatus[no] &= ~KOMA_ENABLE;
		SetActive( no, FALSE );
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
// Xe[^Xݒ
BOOL	CKoma::SetStatus( 
			int no,
			KOMAID kid,
			CPoint cp,
			BOOL side,
			BOOL nari /*= FALSE*/,
			BOOL active /*= TRUE*/,
			BOOL enable /*=TRUE*/ )
{
	if( no > 39 || no < 0 )
		return FALSE;

	SetID( no, kid );
	SetPoint( no, cp );
	SetSide( no, side );
	SetNari( no, nari );
	SetActive( no, active );
	SetEnable( no, enable );
	
	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
// ̈ʒu̔]

inline CPoint CKoma::ReversePoint( int no )
{
	if( IsEnable( no ) && IsActive( no ) )
		return SetPoint( no, CPoint(8,8)-GetPoint(no) );
	return GetPoint( no );
}


//////////////////////////////////////////////////////////////////////////////
// SĂ̋̈ʒu̔]

inline void CKoma::ReverseAll()
{
	for( int no=0; no<40; no++ )
			ReversePoint( no );
}


//////////////////////////////////////////////////////////////////////////////
// 

int CKoma::CheckNariFlag(int no, CPoint cpE)
{

	CPoint cpS = GetPoint(no);

	if(GetSide(no)==GOTE)
	{
		ReverseAll();
		cpE = CPoint(8,8) - cpE;
		cpS = CPoint(8,8) - cpS;
	}

	int ret = NR_NO;

	if( ( (cpE.y < 3)||(cpS.y < 3) )&&
		(!IsNari(no))&&				// ܂łȂ
		(IsActive(no)))				// Ղ̏ɂ
	{
		ret = NR_ABLE;
		//  ̃`FbN
		switch( GetID(no) )
		{
		case GYOKU:
		case KIN:
			ret = NR_NO;
			break;

		case KEIMA:							// jn
			if(cpE.y<2)
				ret = NR_MUST;
			break;

		case KYOSYA:						// 
		case FU:
			if(cpE.y<1)
				ret = NR_MUST;
			break;

		default:
			break;
		}
	}

	if(GetSide(no)==GOTE)
		ReverseAll();

	return ret;

}

//////////////////////////////////////////////////////////////////////////////
// ׂĂ̋̐𔽓]

void CKoma::ReverseAllFlags()
{
	for( int no=0; no<40; no++ )
	{
		if(GetSide(no)==SENTE)
			SetSide(no,GOTE);
		else
			SetSide(no,SENTE);
		ReversePoint( no );
	}
}


//////////////////////////////////////////////////////////////////////////////
// ͓̋GɎ邩H

BOOL CKoma::IsBeDead(int no)
{
	int nSide = GetSide(no);
	BOOL ret = FALSE;

	// 肷̏ꍇ́Aׂ͌̋
	// 䂦ɔ]B
	if( nSide == SENTE )
		ReverseAll();
	
	for( int nIndex = 0; nIndex < 40; nIndex++ )
	{
		if( (nIndex == no)||(GetSide(nIndex)==nSide) )
			continue;

		if(CheckMovePoint( nIndex, GetPoint(no) ))
		{
			ret = TRUE;
			break;
		}
	}
	if( nSide == SENTE )
		ReverseAll();

	return ret;
}


//////////////////////////////////////////////////////////////////////////////
// ̋ʂ̔wԍ𓾂

int CKoma::GetGyokuNo(int nSide)
{
	for( int nIndex = 0; nIndex < 40; nIndex++ )
	{
		if((GetID(nIndex)==GYOKU)&&(GetSide(nIndex)==nSide))
			return nIndex;
	}
	return -1;
}


//////////////////////////////////////////////////////////////////////////////
// O

CString	CKoma::GetName( int no )
{
	CString name = _T("??");
	static char* kanjiname[] = {
		"",
		"","",
		"p","n",
		"",
		"","",
		"j","j",
		"","",
		"","" };

	int id[] = { 0, 1, 3, 5, 6, 8, 10, 12, 13 };
	int kanjino =  id[GetID(no)] + (IsNari(no)?1:0);
	if( kanjino < 0 || kanjino > 13 )
		name = "??";
	else
		name = kanjiname[kanjino];
	return name;
}

void CKoma::GetTeaiString(CString &csTeaiStr)
{
	char* kanjiname[] = {
		"",		// 0
		"",	// 1
		"p",	// 2
		"ԗ",	// 3
		"򍁗",	// 4
		"񖇗",	// 5
		"l",	// 6
		"Z",	// 7
		"̑"};

		if( m_nOti>=0 && m_nOti<=7)
			csTeaiStr = kanjiname[m_nOti];
		else
			csTeaiStr = _T("̑");
}
