// SockStatus.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "nshogi2.h"
#include "SockStatus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSockStatus _CAO


CSockStatus::CSockStatus(CNSDoc* pDoc, CWnd* pParent /*=NULL*/)
	: CDialog(CSockStatus::IDD, pParent)
{
	m_pDoc = pDoc;
	//{{AFX_DATA_INIT(CSockStatus)
	m_strHostName = _T("");
	m_strPeerName = _T("");
	m_strHostPort = _T("");
	m_strPeerPort = _T("");
	//}}AFX_DATA_INIT
}


void CSockStatus::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSockStatus)
	DDX_Control(pDX, IDLC_WATCHER, m_lstWatcher);
	DDX_Control(pDX, IDC_MYADDR, m_cmbMyAddr);
	DDX_Text(pDX, IDSC_HOSTNAME, m_strHostName);
	DDX_Text(pDX, IDSC_PEERNAME, m_strPeerName);
	DDX_Text(pDX, IDSC_HOSTPORT, m_strHostPort);
	DDX_Text(pDX, IDSC_PEERPORT, m_strPeerPort);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSockStatus, CDialog)
	//{{AFX_MSG_MAP(CSockStatus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSockStatus bZ[W nh

BOOL CSockStatus::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// ̎ĂIPAhXSė
	char** hostaddr = GetHostAddr();
	while( *hostaddr != NULL )
	{
		char* adr = *hostaddr;
		CString cs;
		cs.Format( "%d.%d.%d.%d", (UCHAR)adr[0], (UCHAR)adr[1], (UCHAR)adr[2], (UCHAR)adr[3] );
		m_cmbMyAddr.AddString( cs );
		hostaddr++;
	}
	m_cmbMyAddr.SetCurSel(0);

	CString cs = "";
	UINT	ii = 0;

	// IPAhX
	if( m_pDoc->m_pSocket )
	{
		if( m_pDoc->m_pSocket->GetSockName( cs, ii ) )
		{
			m_strHostName = cs;
			m_strHostPort.Format( "%d", ii );
		}
		if( m_pDoc->m_pSocket->GetPeerName( cs, ii ) )
		{
			m_strPeerName = cs;
			m_strPeerPort.Format( "%d", ii );
		}
	}

	POSITION pos;
	for(pos = m_pDoc->m_connectionList.GetHeadPosition(); pos != NULL;)
	{
		CWatchSocket* pSock = (CWatchSocket*)(m_pDoc->m_connectionList.GetNext(pos));
		// ̖O
		CString csWatcher = *pSock->m_szName;
		
		// IPAhX
		CString csIpAdd;
		m_pDoc->m_pSocket->GetPeerName( csIpAdd, ii ) ;

		CString csTmp;
		csTmp.Format( " : %s[%d]", csIpAdd, ii );
		csWatcher += csTmp;
		m_lstWatcher.AddString(csWatcher);
	}

	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
